using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(Rigidbody))]
public class RigidbodyFact : MonoBehaviour
{
    Rigidbody ribot;
    private bool isOriginal = true;

    void Awake()
    {
        ribot = gameObject.GetComponent<Rigidbody>();
    }

    private void CloneAndSend(RaycastHit[] _)
    {
        if (!isOriginal) return;

        GameObject clone = GameObject.Instantiate(gameObject, transform.parent);
        var clRbF = clone.GetComponent<RigidbodyFact>();
        clRbF.isOriginal = false;
        clRbF.RandomMovement(null);
    }

    private void RandomMovement(RaycastHit[] _)
    {
        gameObject.GetComponent<SphereCollider>().enabled = true;
        ribot.isKinematic = false;
        ribot.AddForce(
            Random.rotationUniform * Vector3.up,
            ForceMode.VelocityChange
            );
    }

    void OnEnable()
        => CommunicationEvents.TriggerModFireEvent.AddListener(CloneAndSend);

    void OnDisable()
        => CommunicationEvents.TriggerModFireEvent.RemoveListener(CloneAndSend);
}
